
From: Johannes Stezenbach <js@linuxtv.org>

Fix DiSEqC switching (one bug fix suggested by Peter Hettkamp, and one
experimentally determined msleep(30) suggested by Adam Szalkowski).

Signed-off-by: Johannes Stezenbach <js@linuxtv.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/media/dvb/frontends/cx24110.c |    5 +++--
 1 files changed, 3 insertions(+), 2 deletions(-)

diff -puN drivers/media/dvb/frontends/cx24110.c~dvb-frontend-cx24110-diseqc-fix drivers/media/dvb/frontends/cx24110.c
--- devel/drivers/media/dvb/frontends/cx24110.c~dvb-frontend-cx24110-diseqc-fix	2005-09-04 16:51:18.000000000 -0700
+++ devel-akpm/drivers/media/dvb/frontends/cx24110.c	2005-09-04 16:51:18.000000000 -0700
@@ -398,7 +398,7 @@ static int cx24110_diseqc_send_burst(str
 		return -EINVAL;
 
 	rv = cx24110_readreg(state, 0x77);
-	cx24110_writereg(state, 0x77, rv|0x04);
+	cx24110_writereg(state, 0x77, rv | 0x04);
 
 	rv = cx24110_readreg(state, 0x76);
 	cx24110_writereg(state, 0x76, ((rv & 0x90) | 0x40 | bit));
@@ -418,7 +418,8 @@ static int cx24110_send_diseqc_msg(struc
 		cx24110_writereg(state, 0x79 + i, cmd->msg[i]);
 
 	rv = cx24110_readreg(state, 0x77);
-	cx24110_writereg(state, 0x77, rv|0x04);
+	cx24110_writereg(state, 0x77, rv & ~0x04);
+	msleep(30); /* reportedly fixes switching problems */
 
 	rv = cx24110_readreg(state, 0x76);
 
_
